///File : ScrolPanelSections.hpp
//------------------------------------------------------------------------------
/*
    This file is part of DevisMaker.

    DevisMaker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DevisMaker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DevisMaker.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------

#if not defined SCROL_PANEL_ROOMS_HPP_DEVIS_MAKER
#define SCROL_PANEL_ROOMS_HPP_DEVIS_MAKER
//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/vscroll.h>
#include <wx/event.h>
#include <wx/stdpaths.h>
#include <wx/statline.h>
#include <wx/spinctrl.h>
//------------------------------------------------------------------------------
#include "config.hpp"
#include "buildVersionOptions.hpp"
#include <DevisManager.hpp>
//------------------------------------------------------------------------------
#include "strWxStdConv.hpp"
#include "MainPanel.hpp"
#include "DialogItemSearch.hpp"
#include "DialogBarCodeRead.hpp"
//------------------------------------------------------------------------------
#include <vector>
//------------------------------------------------------------------------------

//class MainFrame;  //On déclare MainFrame avant pr pouvoir l'utiliser juste après.

//#if defined(__WXMSW__)
    #define USE_SCROLLED_WINDOW
//#endif // __WXMSW__

struct itemControls
{
    wxChoice* ItemChoices;
    wxTextCtrl* ItemNumbers;
    wxStaticText* ItemCaptions;
    wxButton* ItemBtRm;
    wxBitmapButton* ItemSearch;
};

#if defined USE_SCROLLED_WINDOW
class ScrollPanelItems : public wxVScrolledWindow
#else
class ScrollPanelItems : public wxPanel
#endif
{
public:
    ScrollPanelItems(wxWindow* parent, DevisManager *devisManager, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTAB_TRAVERSAL );

    #if defined USE_SCROLLED_WINDOW
        //virtual wxCoord OnGetRowHeight(size_t row) const;
        virtual wxCoord OnGetLineHeight(size_t line) const;
    #endif

    void OnAddItem(wxCommandEvent& event);
    #if defined USE_BAR_CODE_MODE
    void OnDialogBarCode(wxCommandEvent& event);
    #endif // #if defined USE_BAR_CODE_MODE

    void OnRemoveItem(wxCommandEvent& event);
    void OnChoice(wxCommandEvent& event);
    void OnChangeQuantity(wxCommandEvent& event);
    void OnItemSearch(wxCommandEvent& event);

    void EnableBt(const bool &enable);

    void RefreshLabel(const int &pos = -1);
    void SetPosSection(const int &posSection);
    void RemoveItem(const size_t &pos);
    int AddItem();
    void ClearAll();
    bool FindPosWithID(const wxWindowID &id, size_t &pos);
    void UpdateDevisItemFromGUI(const size_t &pos);
    void UpdateGUIItemFromDevis(const size_t &pos);
    void UpdateAllItemsList();

protected:
    wxStaticText *m_SectionPrice;

    DevisManager *m_DevisManager;

    wxButton *m_btAddItem;
    #if defined USE_BAR_CODE_MODE
    wxButton *m_btBarCode;
    #endif // #if defined USE_BAR_CODE_MODE

    int m_posSection;

    wxBoxSizer* m_MainSizer;

    // All items list
    wxArrayString m_wxAllItemsList;
    std::vector<std::string> m_stdAllItemsList;

    // Ctrls
    std::vector<itemControls> m_itemControls;
};

#endif //SCROL_PANEL_ROOMS_HPP_DEVIS_MAKER
